import matplotlib.pyplot as plt
from collections import OrderedDict


# From single_sdevice.py scenario
eff_factor_test_results=OrderedDict(sorted({
  'e=1.0': [+0.245, +0.138, +0.060, +0.000, -0.046, -0.081, -0.108, -0.129, -0.144, -0.155, -0.163, -0.166, -0.060, -0.057, -0.050, -0.040, -0.026, -0.007, +0.018, +0.049, +0.088, +0.139, +0.204, +0.290],
  'e=0.9': [+0.208, +0.104, +0.028, +0.000, -0.005, -0.041, -0.070, -0.091, -0.108, -0.119, -0.127, -0.130, -0.028, -0.025, -0.019, -0.005, -0.000, -0.000, +0.000, +0.021, +0.059, +0.108, +0.170, +0.253],
  'e=0.8': [+0.163, +0.063, +0.000, +0.000, -0.000, -0.001, -0.031, -0.053, -0.070, -0.082, -0.090, -0.093, -0.000, -0.000, -0.000, -0.000, -0.000, +0.000, +0.000, +0.000, +0.023, +0.069, +0.129, +0.208],
  'e=0.7': [+0.112, +0.016, +0.000, -0.000, +0.000, -0.000, -0.000, -0.013, -0.031, -0.043, -0.051, -0.055, -0.000, +0.000, -0.000, -0.000, +0.000, +0.000, -0.000, -0.000, -0.000, +0.026, +0.082, +0.157],
  'e=0.6': [+0.053, +0.000, +0.000, +0.000, -0.000, +0.000, -0.000, -0.000, -0.001, -0.014, -0.022, -0.026, +0.000, +0.000, +0.000, +0.000, -0.000, +0.000, -0.000, +0.000, +0.000, -0.000, +0.027, +0.097],
  'e=0.5': [-0.000, -0.000, -0.000, -0.000, -0.000, +0.000, -0.000, -0.000, -0.000, -0.000, -0.003, -0.007, -0.000, -0.000, +0.000, -0.000, +0.000, +0.000, -0.000, -0.000, +0.000, +0.000, -0.000, +0.036]
}.items()))

# From single_sdevice.py scenario
sustainment_factor_test_results=OrderedDict(sorted({
's=1.0':[+0.471, +0.237, +0.085, -0.019, -0.094, -0.148, -0.189, -0.219, -0.242, -0.257, -0.267, -0.272, -0.103, -0.098, -0.089, -0.074, -0.054, -0.025, +0.012, +0.063, +0.131, +0.225, +0.360, +0.565],
's=0.99':[+0.440, +0.217, +0.074, -0.024, -0.093, -0.143, -0.179, -0.205, -0.222, -0.234, -0.239, -0.240, -0.070, -0.061, -0.047, -0.026, +0.001, +0.036, +0.083, +0.144, +0.225, +0.337, +0.497, +0.737],
's=0.98':[+0.391, +0.181, +0.047, -0.043, -0.106, -0.150, -0.181, -0.202, -0.215, -0.221, -0.222, -0.217, -0.046, -0.032, -0.012, +0.014, +0.048, +0.092, +0.148, +0.221, +0.318, +0.450, +0.637, +0.918],
's=0.95':[+0.180, +0.012, -0.092, -0.160, -0.204, -0.233, -0.249, -0.256, -0.256, -0.249, -0.236, -0.216, -0.031, -0.002, +0.035, +0.080, +0.135, +0.205, +0.292, +0.404, +0.551, +0.750, +1.030, +1.449],
's=0.90':[+0.011, -0.121, -0.199, -0.245, -0.269, -0.278, -0.274, -0.260, -0.236, -0.202, -0.158, -0.104, -0.000, -0.000, -0.000, -0.000, +0.072, +0.168, +0.289, +0.446, +0.654, +0.939, +1.346, +1.964],
's=0.80':[-0.127, -0.228, -0.276, -0.290, -0.279, -0.243, -0.184, -0.098, +0.000, +0.000, +0.000, +0.000, +0.000, -0.000, +0.000, +0.000, -0.000, +0.000, +0.090, +0.288, +0.570, +0.982, +1.615, +2.640]
}.items()))


for k,v, in eff_factor_test_results.items():
  plt.plot(v, label=k)
plt.grid(True, zorder=5)
plt.legend()
plt.xlabel('Time')
plt.ylabel('RoC')
plt.title('Storage device RoC profile over time for differing efficiency factors')
plt.savefig('efficiency-factor.png')
plt.cla()

for k,v, in sustainment_factor_test_results.items():
  plt.plot(v, label=k)
plt.grid(True, zorder=5)
plt.legend()
plt.xlabel('Time')
plt.ylabel('RoC')
plt.title('Storage device RoC profile over time for differing sustainment factors')
plt.savefig('sustainment-factor.png')
